/* NoSuch MIDI - Copyright 1997-1998 by Tim Thompson */

package com.nosuch.cooking;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;
import java.io.*;
import java.net.*;
import com.nosuch.midi.*;

// There is one of these objects for each choice in the drum button.
class DrumInfo implements Externalizable {
	String label;
	MidiPhrase note;
	String category;

	public DrumInfo() {	// needed by readObject()
	}

	public DrumInfo(String lb, MidiPhrase nt, String cat) {
		label = lb;
		note = nt;
		category = cat;
	}
	public String toString() {
		return "DrumInfo("+label+","+category;
	}
	public void writeExternal(ObjectOutput out) throws IOException {
		out.writeUTF(label);
		out.writeObject(note);
		out.writeUTF(category);
	}
	public void readExternal(ObjectInput in) throws IOException {
		label = in.readUTF();
		try {
			note = (MidiPhrase)in.readObject();
		} catch (ClassNotFoundException e) {
			System.out.println("Error reading external into DrumInfo");
			note = null;
		}
		category = in.readUTF();
	}
}

