/* NoSuch MIDI - Copyright 1997-1998 by Tim Thompson */

package com.nosuch.cooking;

import java.io.*;
import java.util.*;

public class KitchenData {

	static String sep = System.getProperty("file.separator");
	static Properties _props;
	static String _uifname;
	static boolean _loaded = false;

	public static String getUserName() {
		loadFile();
		return (String) _props.get("name");
	}

	public static String getEmail() {
		loadFile();
		return (String) _props.get("email");
	}

	public static void setUserName(String s) {
		_props.put("name",s);
		writeout();
	}

	public static void setEmail(String s) {
		_props.put("email",s);
		writeout();
	}

	private static void writeout() {
		try {
			FileOutputStream fout = new FileOutputStream(_uifname);
			_props.save(fout,"# Kitchen properties");
			fout.close();
		} catch (IOException e) {
			System.err.println("Unable to create "+_uifname);
			return;
		}
	}

	private static void loadFile() {
		if ( _loaded )
			return;
		_props = new Properties();
		String datadirname = Kitchen.root + sep + "data";
		File datadir = new File(datadirname);
		if ( ! datadir.isDirectory() )
			datadir.mkdir();
		_uifname = datadirname + sep + "userinfo";
		File userinfo = new File(_uifname);
		if ( ! userinfo.exists() ) {
			try {
				FileOutputStream fout = new FileOutputStream(userinfo);
				fout.close();
			} catch (IOException e) {
				System.err.println("Unable to create "+_uifname);
				return;
			}
		}
		try {
			FileInputStream fin = new FileInputStream(_uifname);
			_props.load(fin);
			fin.close();
		} catch (IOException e) {
			System.err.println("Unable to read "+_uifname);
			return;
		}
		_loaded = true;
	}
}
