/* NoSuch MIDI - Copyright 1997-1998 by Tim Thompson */

package com.nosuch.cooking;

import java.net.*;
import java.io.*;
import java.util.*;

public class KitchenServer extends Thread {

	public static int DEFAULTPORT = 8354;
	int port;

	KitchenServer() {
		this(DEFAULTPORT);
	}

	KitchenServer(int p) {
		port = p;
	}

	public void run() {
		System.out.println("KitchenServer listening on port "+port);
		ServerSocket sock;
		try {
			sock = new ServerSocket(port,8);
		} catch (Exception e) {
			System.out.println("KitchenServer unable to listen on port="+port);
			return;
		}
		while ( true ) {
			try {
				Socket s = sock.accept();
				Thread t = new KitchenServerTalker(s,this);
				t.start();
			} catch (Exception e) {
				System.out.println("Exception in KitchenServer msg="+e.getMessage());
			}
		}
	}
}

class KitchenServerTalker extends Thread {
	Socket sock;
	KitchenServer parent;
	KitchenServerTalker(Socket s, KitchenServer srv) {
		sock = s;
		parent = srv;
	}
	public void run() {
		InputStream in;
		try {
			in = sock.getInputStream();
		} catch (Exception e) {
			System.out.println("Exception while creating streams in KitchenServerTalker!");
			return;
		}
		StringBuffer buff = new StringBuffer();
		while ( true ) {
			int c;
			try {
				c = in.read();
			} catch (Exception e) {
				break;
			}
			if ( c < 0 )
				break;
			char ch = (char)c;
			if ( ch == '\r' || ch == '\n' )
				break;
			buff.append((char)c);
		}
		String line = buff.toString();
System.out.println("got line="+line);
		StringTokenizer w = new StringTokenizer(line);
		String w1, w2;
		w1 = w2 = null;
		if ( w.hasMoreTokens() )
			w1 = w.nextToken();
		if ( w.hasMoreTokens() )
			w2 = w.nextToken();
		if ( w1 != null && w2 != null ) {
System.out.println("w1="+w1+" w2="+w2);

			Cooklet ck = Kitchen.createCooklet("com.nosuch.cooking."+w1,null);
System.out.println("About to read object");

			// BoomerState bs = new BoomerState();
			Integer i1;

			try {
				ObjectInputStream s = new ObjectInputStream(in);
				ck.readExternal(s);
				ck.repaint();

				// = (BoomerState)s.readObject();
				// i1 = (Integer)s.readObject();
			} catch (Exception ie) {
				System.out.println("Exception reading object msg="+ie);
				ie.printStackTrace();
			}

System.out.println("After reading object");

		}
		try {
			in.close();
		} catch (Exception e) {
		}
	}
}
