/* NoSuch MIDI - Copyright 1997-1998 by Tim Thompson */

package com.nosuch.cooking;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.applet.*;
import com.nosuch.midi.*;

public class Volume extends Cooklet {

	VolumePanel p;

	public Dimension getPreferredSize() {
		return new Dimension(50, 200);
	}
	public String getName() {
		return "Volume";
	}

	public Panel getPanel() {
		p = new VolumePanel();
		return p;
	}

	// nested class
	class VolumePanel extends Panel implements AdjustmentListener {

		Scrollbar sb;

		public VolumePanel() {
			setLayout(new GridLayout(0,1));
			add(sb = new Scrollbar(Scrollbar.VERTICAL,64,1,0,128));
			sb.addAdjustmentListener(this);
		}
		public void adjustmentValueChanged(AdjustmentEvent e) {
			sb.setValue(e.getValue());
			try {
				MidiSystem.schedule(Alg.gvolchange(127-e.getValue()));
			} catch (MidiException me) { }
		}
	}

	// If it is resized wider than it is tall,
	// the slider orientation gets changed automatically.

	public void componentResized(ComponentEvent e) {
		Dimension d = getSize();
		int o;
		if ( d.width > d.height )
			o = Scrollbar.HORIZONTAL;
		else
			o = Scrollbar.VERTICAL;
		if ( p.sb.getOrientation() != o )
			p.sb.setOrientation(o);
	}
	public void writeExternal(ObjectOutput out) throws IOException {
	}
	public void readExternal(ObjectInput in) throws IOException {
	}
}

