/* NoSuch MIDI - Copyright 1997 by Tim Thompson */

package com.nosuch.midi;

/**
 * An Enumeration for traversing the messages in a MidiPhrase.
 *
 * @author Tim Thompson
 */

import java.util.Enumeration;

public class MidiPhraseEnumeration implements Enumeration {

	private MidiMsg m;

	/**
	 * Create a new enumerator on the specified MidiPhrase
	 * @param p MidiPhrase to traverse.
	 */
	public MidiPhraseEnumeration(MidiPhrase p) {
		m = p._msg;
	}

	/** Return true if the phrase has more elements to be traversed */
	public boolean hasMoreElements() {
		if ( m == null )
			return false;
		else
			return true;
	}

	/** Return the next element in the phrase */
	public Object nextElement() {
		MidiMsg thism = m;
		if ( m != null )
			m = m.next;
		return thism;
	}
}
